// \AvP[V
//    u@@@v@
// vZ֌W (calcfft.cpp)  

#include "calcfft.h"
#include "common.h"

//-------------------------------------
// Wave t@Cǂݍ
// _CAOJāAvV[WŌvZXbhN
BOOL ReadWave(HWND hWnd,HINSTANCE hInst,
			  LPHANDLE lpHdWaveFile,
			  DWORD fftPoint,WORD winFunc, LPSCROLLINFO lpTimeInfo,
			  DWORD adjustAmp,LPBYTE* lppWaveData,
			  double** lppdFftData, 
			  LPWAVEFORMATEX lpWaveFmt,
			  LPDWORD lpWaveDataOffset,
			  LPDWORD lpWaveDataSize,
			  LPSTR lpFileName, 
			  LPDWORD lpdwFileSize,
			  LPBYTE* lppBitBuf,
			  LPBITMAPINFO*  lppBitInfo,
			  LPBYTE* lppBit,
			  HBITMAP* lpHbDIB,
			  BOOL bLogX,BOOL bMono){
	
	static FFTDATA fftData; // Xbhɓnf[^
	
	// Xbhɓnf[^Zbg
	fftData.lpHdWaveFile = lpHdWaveFile;
	fftData.fftPoint =  fftPoint;
	fftData.winFunc =  winFunc;
	fftData.adjustAmp  =  adjustAmp;
	fftData.lppWaveData = lppWaveData;
	fftData.lppdFftData =   lppdFftData;
	fftData.lpWaveFmt  =  lpWaveFmt;
	fftData.lpWaveDataOffset  =  lpWaveDataOffset;
	fftData.lpWaveDataSize  =  lpWaveDataSize;
	fftData.lpFileName  = lpFileName;
	fftData.lppBitBuf  =  lppBitBuf;
	fftData.lppBitInfo  =  lppBitInfo;
    fftData.lppBit =  lppBit;
	fftData.lpHbDIB  = lpHbDIB;
	fftData.lpFileSize = lpdwFileSize;
	fftData.bLogX = bLogX;
	fftData.bMono = bMono;
	
	// _CAO{bNX\ƌvZJn
	if(DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_CALC)
		,hWnd,(DLGPROC)CalcDlgProc,
		(LPARAM)&fftData) == IDOK){
		
		// I
	
		// eݒpϐ
		DWORD dwBlockNo;
		LONG waveRate;	// Wave [g			
		SHORT waveChn,waveBit;	// Wave `lArbg
		DWORD waveTime;  // t(msec)
		
		// t@C擾pϐ
		CHAR fileName[CHR_BUF],changeDir[CHR_BUF];
		CHAR fPath[CHR_BUF],fDrive[CHR_BUF],fName[CHR_BUF],fExt[CHR_BUF]; 
		
		// Gp
		CHAR str[CHR_BUF];
		
		waveChn = (SHORT)lpWaveFmt->nChannels;  // `l
		waveRate = (LONG)lpWaveFmt->nSamplesPerSec; // [g
		waveBit = (SHORT)lpWaveFmt->wBitsPerSample; // rbg
		dwBlockNo = *lpWaveDataSize/(fftPoint*lpWaveFmt->nBlockAlign)+1; // vbN(+1 Ă̂͏_؂グ̂)
		waveTime = (DWORD)((double)(*lpWaveDataSize)/(double)lpWaveFmt->nAvgBytesPerSec*1000); // t
			
		// t@C擾
		_splitpath(lpFileName,NULL,NULL,fName, fExt);	
		wsprintf(fileName,"%s%s",fName,fExt);  
		
		// ^CgύX									   	
		wsprintf(str,"  - %s",fileName);  
		SetWindowText(hWnd,(LPCSTR)str); 
		
		// Xe[^Xo[XV
		CHAR *stereoOrMono[2]={"mono","stereo"};
		
		wsprintf(str,"%d byte, %s, %d Hz, %d bit, %d.%03d sec, %d point"
			,*lpdwFileSize,stereoOrMono[waveChn-1],waveRate,waveBit
			,waveTime/1000,
			waveTime-(waveTime/1000)*1000,
			fftPoint);  
		
		SendMessage(GetDlgItem(hWnd,ID_STATBAR),SB_SETTEXT,0|0,(LPARAM)str);
		SendMessage(GetDlgItem(hWnd,ID_STATBAR),SB_SETTEXT,1|0,(LPARAM)""); 
		SendMessage(GetDlgItem(hWnd,ID_STATBAR),SB_SETTEXT,2|0,(LPARAM)"   0.0000 s"); 
		
		// j[XV		
		HMENU hMenu;   
		hMenu = GetMenu(hWnd); 
		EnableMenuItem(hMenu,IDM_CLOSE,MF_ENABLED);	
		EnableMenuItem(hMenu,IDM_SAVE,MF_ENABLED);	 
		EnableMenuItem(hMenu,IDM_COPY,MF_ENABLED);
		EnableMenuItem(hMenu,IDM_TOHEAD,MF_ENABLED);				
		EnableMenuItem(hMenu,IDM_REWIND,MF_ENABLED);  
		EnableMenuItem(hMenu,IDM_PLAY,MF_ENABLED);	 										
		EnableMenuItem(hMenu,IDM_PAUSE,MF_ENABLED);
		EnableMenuItem(hMenu,IDM_FORWARD,MF_ENABLED);  
		EnableMenuItem(hMenu,IDM_TOTAIL,MF_ENABLED);	 										
		
		// c[o[XV
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBCLOSE,(LPARAM)MAKELONG(TRUE, 0));	
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBTOHEAD,(LPARAM)MAKELONG(TRUE, 0));	
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBREWIND,(LPARAM)MAKELONG(TRUE, 0));	
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBPLAY,(LPARAM)MAKELONG(TRUE, 0));	
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBPAUSE,(LPARAM)MAKELONG(TRUE, 0));	
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBFORWARD,(LPARAM)MAKELONG(TRUE, 0));	
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBTOTAIL,(LPARAM)MAKELONG(TRUE, 0));	
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBCOPY,(LPARAM)MAKELONG(TRUE, 0));	
		SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
			TB_ENABLEBUTTON,(WPARAM)ID_TBSAVE,(LPARAM)MAKELONG(TRUE, 0));	
		
		// XN[o[̃Zbg
		lpTimeInfo->nMin = 0;	
		lpTimeInfo->nMax = dwBlockNo-1;
		lpTimeInfo->nPage = lpTimeInfo->nMax/20;
		lpTimeInfo->nPos = 0;
		
		SendMessage(GetDlgItem(hWnd,ID_SCRBAR),TBM_SETRANGE
			,(WPARAM)TRUE,MAKELPARAM(lpTimeInfo->nMin,lpTimeInfo->nMax));
		SendMessage(GetDlgItem(hWnd,ID_SCRBAR),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)(lpTimeInfo->nPos)); 
		
		// fBNgړ
		
		_splitpath(lpFileName,fDrive,fPath,fName,fExt);
		wsprintf(changeDir,"%s%s",fDrive,fPath); 
		SetCurrentDirectory(changeDir);  
		
		// I
		return TRUE;
	}
	
	// ُI(main ɖ߂ InitData() Ăŏ)
	return FALSE;
}


//-------------------------------------
// _CAO{bNX̃vV[W
LRESULT CALLBACK CalcDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	
	static HANDLE hThread;  // vZXbh̃nh
	DWORD threadId; // Xbh ID
	static WORD threadStatus; // Xbh̏
	static PFFTDATA pFftData; // Xbhɓnf[^^Cv
	
    switch (msg) {

	case WM_INITDIALOG:  // _CAO

		// ẽnh擾
		HWND hParentWnd; 
		hParentWnd = GetParent(hWnd);
		
		// _CAO𒆐SɈړ
		RECT parentrc, rc;
		int x, y, w ,h ;
		GetWindowRect(hParentWnd, &parentrc);
		GetWindowRect(hWnd, &rc);
		x = parentrc.left+((parentrc.right-parentrc.left) - (rc.right-rc.left)) / 2;
		y = parentrc.top+((parentrc.bottom-parentrc.top) - (rc.bottom-rc.top)) / 2;
		w = (rc.right-rc.left);
		h = (rc.bottom-rc.top);
		SetWindowPos(hWnd, HWND_TOP, x, y, w, h ,SWP_SHOWWINDOW); 
		
		// vZXbhN
		pFftData = (PFFTDATA)lp;
		pFftData->hWnd = hWnd;
		pFftData->lpThreadStatus = &threadStatus;
		
		hThread = CreateThread(NULL,0,
			(LPTHREAD_START_ROUTINE)CalcThread,
			(LPVOID)pFftData,
			0,(LPDWORD)&threadId);

		if(hThread == NULL){	   
			MessageBox(hWnd, "Xbh̋NɎs܂B", 
				"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
			EndDialog(hWnd, IDCANCEL); 
		}
		
		break;
		
		
	case WM_MYENDCALC: // vZ
		
		hThread = NULL;
		
		if((DWORD)lp == 1) EndDialog(hWnd, IDCANCEL); // ُI
		else EndDialog(hWnd, IDOK);  // I
		
		break;
		
	case WM_COMMAND:
		
		switch (LOWORD(wp)) {
			
		case IDCANCEL:	
			
			if(hThread != NULL && threadStatus == ID_THREADON)
				threadStatus = ID_THREADSTOP; // Xbh~v
			
			break;
			
		default:
			return FALSE;
        }
		
        default:
			return FALSE;
    }
    return TRUE;
}


//-------------------------------------------------------------------
// vZXbh
DWORD WINAPI CalcThread(LPVOID lpFftData){
				
	// f[^擾
	LPWORD lpThreadStatus = ((PFFTDATA)lpFftData)->lpThreadStatus;
	HWND hWnd = ((PFFTDATA)lpFftData) -> hWnd; 
	LPHANDLE lpHdWaveFile = ((PFFTDATA)lpFftData)->lpHdWaveFile;
	DWORD fftPoint = ((PFFTDATA)lpFftData) -> fftPoint;
	WORD winFunc = ((PFFTDATA)lpFftData) -> winFunc;
	DWORD adjustAmp  = ((PFFTDATA)lpFftData) -> adjustAmp;
	LPBYTE* lppWaveData = ((PFFTDATA)lpFftData) -> lppWaveData;
	double** lppdFftData =  ((PFFTDATA)lpFftData) -> lppdFftData;
	LPWAVEFORMATEX lpWaveFmt  = ((PFFTDATA)lpFftData) -> lpWaveFmt;
	LPDWORD lpWaveDataOffset  = ((PFFTDATA)lpFftData) -> lpWaveDataOffset;
	LPDWORD lpWaveDataSize  = ((PFFTDATA)lpFftData) -> lpWaveDataSize;
	LPSTR lpFileName  = ((PFFTDATA)lpFftData) -> lpFileName;
	LPBYTE* lppBitBuf  = ((PFFTDATA)lpFftData) -> lppBitBuf;
	LPBITMAPINFO*  lppBitInfo  = ((PFFTDATA)lpFftData) -> lppBitInfo;
    LPBYTE* lppBit = ((PFFTDATA)lpFftData) -> lppBit;
	HBITMAP* lpHbDIB  = ((PFFTDATA)lpFftData) -> lpHbDIB;
	LPDWORD  lpdwFileSize  = ((PFFTDATA)lpFftData) -> lpFileSize;
	BOOL bLogX = ((PFFTDATA)lpFftData) -> bLogX;
	BOOL bMono = ((PFFTDATA)lpFftData) -> bMono;


	// t@Cǂݍݗpϐ
	HANDLE hFile; // t@Cnh
	DWORD dwByte;  
	
	LONG waveRate;	// Wave [g			
	SHORT waveChn,waveBit;	// Wave `lArbg
	DWORD waveTime;  // t (msec)
	
	// FFT f[^ (1 `l)ƉvbN
	DWORD dwFftHeight,dwBlockNo; 
	DWORD outBitWidth,outBitHeight;	//@bitmap ̕ƍ
	
	// Xbh̏ԃZbg
	*lpThreadStatus = ID_THREADON;
	
	//------------------------------------
	// t@CI[v
	
	// WAVE tH[}bgZbg
	if(GetWaveFormat(hWnd,lpFileName,lpWaveFmt
		,lpWaveDataSize,lpWaveDataOffset,&waveTime,TRUE)==FALSE){
		
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		*lpThreadStatus = ID_THREADEND;
		ExitThread(1L);
	}

	// e@WAVE vZ
	waveChn = (SHORT)lpWaveFmt->nChannels;  // `l
	waveRate = (LONG)lpWaveFmt->nSamplesPerSec; // [g
	waveBit = (SHORT)lpWaveFmt->wBitsPerSample; // rbg
	dwBlockNo = *lpWaveDataSize/(fftPoint*lpWaveFmt->nBlockAlign)+1; // vbN(+1 Ă̂͏_؂グ̂)
	dwFftHeight = fftPoint/2;// FFT f[^ (1 `l

	// t@CI[v
	hFile = CreateFile(lpFileName,GENERIC_READ, 
		0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_READONLY, NULL); 
	if(hFile == INVALID_HANDLE_VALUE){
		MessageBox(hWnd, "t@CJ܂B", 
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		*lpThreadStatus = ID_THREADEND;
		ExitThread(1L);		
	}
	
	//t@CTCY擾
	*lpdwFileSize = GetFileSize(hFile, NULL);	 

	// 󃁃`FbN
	DWORD dwNeedMem,dwFreeMem;
	MEMORYSTATUS memStat;
	GlobalMemoryStatus(&memStat);
	dwFreeMem = memStat.dwAvailPhys;
	dwNeedMem = sizeof(double)*dwBlockNo*dwFftHeight*waveChn+(*lpdwFileSize);
	if(dwNeedMem > dwFreeMem){
		CHAR szStr[256];
		wsprintf(szStr,
			"vZɕKvȃTCY %d MA󃁃 %d M\n\nɏ\ȋ󂫂܂B\n̂܂ܑƌvZɎԂ\܂B\n܂H",
			dwNeedMem/1024/1024,dwFreeMem/1024/1024);
		if(MessageBox(hWnd,szStr,"", 
			MB_YESNO|MB_SETFOREGROUND|MB_DEFBUTTON2|MB_ICONQUESTION)==IDNO){
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		*lpThreadStatus = ID_THREADEND;
		ExitThread(1L);		
		}
	}
		
	// obt@̊m
	*lppWaveData=(BYTE*)GlobalAlloc(GPTR,sizeof(BYTE)*(*lpWaveDataSize));
	
	if(*lppWaveData==NULL){	   
		MessageBox(hWnd, "̊mۂɎs܂B", 
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		
		CloseHandle(hFile);
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		*lpThreadStatus = ID_THREADEND;
		ExitThread(1L);
	}
	
	// Wave f[^ǂݍ
	SetFilePointer(hFile, *lpWaveDataOffset, 0, FILE_BEGIN);
	ReadFile(hFile, *lppWaveData, *lpWaveDataSize, &dwByte, NULL);
	
	if(dwByte != *lpWaveDataSize){		 
		MessageBox(hWnd, "f[^Ă܂B",
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	

		CloseHandle(hFile);
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		*lpThreadStatus = ID_THREADEND;	
		ExitThread(1L);
	}

	// t@CǂݍݏI
	//---------------------------------------------------
	// FFT vZ
	
	// FFT f[^̈m  
	*lppdFftData=(double*)GlobalAlloc(GPTR
		,sizeof(double)*dwBlockNo*dwFftHeight*waveChn);
	
	if(*lppdFftData==NULL){
		MessageBox(hWnd, "̊mۂɎs܂B", 
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		
		CloseHandle(hFile);
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		*lpThreadStatus = ID_THREADEND;
		ExitThread(1L);
	}

	//vZԌvp
//	DWORD dwStartTime = timeGetTime(),dwTime;
	
	// vZJn
	CalcWaveFft(lpThreadStatus,GetDlgItem(hWnd,IDC_PROGCALC),fftPoint,winFunc,*lppWaveData,*lppdFftData,*lpWaveFmt,*lpWaveDataSize); 

//	CHAR szStr[256];
//	dwTime = timeGetTime()-dwStartTime;
//	wsprintf(szStr,"%d msec",dwTime);
//	MessageBox(hWnd,szStr,"vZ",MB_OK);	

	// Wave f[^̊J	
	if(GlobalFree(*lppWaveData)!=NULL){ 
		MessageBox(hWnd, "̊JɎs܂B",
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		
		CloseHandle(hFile);
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		*lpThreadStatus = ID_THREADEND;
		ExitThread(1L);
	}
	
	*lppWaveData = NULL;
	
	// Xbh~
	// vZɒ~vĂ炱Œ~
	if(*lpThreadStatus == ID_THREADSTOP){

		CloseHandle(hFile);
		*lpThreadStatus = ID_THREADEND;
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		ExitThread(1L);
	}
	
	// ԂvZIɂ
	*lpThreadStatus = ID_THREADCALCEND;
	
	// vZI
	//---------------------------------------------------
	// 256 F DIB ݒ
	
	// bitmap ̕ƍ̌vZ
	// ڐƃt@C̕]ɂƂĂ
	outBitWidth = dwBlockNo < fftPoint/2 ? fftPoint/2+60 : dwBlockNo+60;
	outBitWidth = outBitWidth+(4-outBitWidth%4);// bitmap@@4 ̔{ɂ
	outBitHeight = (dwFftHeight+25)*waveChn+30;
	
	// 8 bit BITMAP  BITMAPINFO ̐ݒ
	if(!Set8bitDibInfo(lppBitInfo,lppBitBuf,outBitWidth,outBitHeight,bMono)){
		MessageBox(hWnd, "̊mۂɎs܂B",
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);

		CloseHandle(hFile);
		SendMessage(hWnd,WM_MYENDCALC,0,1L);
		*lpThreadStatus = ID_THREADEND;
		ExitThread(1L);
	}
	
	// DIB ̍쐬 
	HDC hDC = GetDC(hWnd);
	*lpHbDIB = CreateDIBSection(hDC, *lppBitInfo, DIB_RGB_COLORS, (VOID**)lppBit, NULL, 0); 
	ReleaseDC(hWnd,hDC);

	// DIB ݒI
	//---------------------------------------------------


	// t@CnhCɓn
	*lpHdWaveFile = hFile;

	// I
	SendMessage(hWnd,WM_MYENDCALC,0,0L); 
	*lpThreadStatus = ID_THREADEND;
	return 0L; 
}



//-------------------------------------------------------------------
// Wavef[^ FFT vZ
VOID CalcWaveFft(LPWORD lpThreadStatus,HWND hProgBar,DWORD fftPoint,WORD winFunc, LPBYTE waveData, double* lpdFftData, 
			 WAVEFORMATEX waveFmt ,DWORD waveDataSize)
{

	COMPLEX data[MAX_FFTPOINT];  // ff[^^

	DWORD i,k; 
	DWORD stereo,maxBit;

	// sin  Ɓ@cos l̃e[u
	// (int)(log(MAX_FFTPOINT)/log(2)+1)*MAX_FFTPOINT/2 eʂ
	double coss[12*MAX_FFTPOINT/2],sinn[12*MAX_FFTPOINT/2] ;  

	// ֐
	double winFuncVal[MAX_FFTPOINT]; 
	
	// WAVE t@Cpϐ
	LONG inData;	  
	DWORD inDataNum;	
	DWORD waveChn,waveBit;  
	DWORD dwFftHeight,dwBlockNo,dwCurBlock; 
	
	// ϐݒ
	waveChn = (DWORD)waveFmt.nChannels; 
	waveBit = (DWORD)waveFmt.wBitsPerSample;
	dwBlockNo = waveDataSize/(fftPoint*waveChn*waveBit/8)+1;  // vbN
	dwFftHeight = fftPoint/2;			  // FFT f[^̍ (1 `lj
	
	// vOXo[ݒ	 
	SendMessage(hProgBar,PBM_SETRANGE,0,MAKELPARAM(0,dwBlockNo/10)); 
	SendMessage(hProgBar,PBM_SETSTEP,(WPARAM)1,0);
	SendMessage(hProgBar,PBM_SETPOS,(WPARAM)0,0);   	   
    
	// vZ̑O cos e[uȂǂZbg
	PreCalcPowerSpec(coss,sinn,&maxBit,fftPoint);
	
	// vZ
	for(k = 0 ; k <  fftPoint ; k++){
		if(winFunc==1) 		// n~O
			winFuncVal[k] = (0.54-0.46*cos(2*PI*(double)k/(fftPoint-1)));  
		else if(winFunc == 2) 		// njO
			winFuncVal[k] = (0.5-0.5*cos(2*PI*(double)k/(fftPoint-1)));  
		else winFuncVal[k] = 1; // `g
	}
	
	//-------------------------------------------------
	//  FFT [`Jn

	for(dwCurBlock=0;dwCurBlock<dwBlockNo;dwCurBlock++) { 
		
		// vZ~
		if(*lpThreadStatus == ID_THREADSTOP) return;
		
		//vOXo[Abv	
		if(dwCurBlock%10==0 || dwCurBlock == dwBlockNo-1) 
			SendMessage(hProgBar,PBM_SETPOS,(WPARAM)((dwCurBlock+1)/10),0);
		
		for(stereo=0;stereo<waveChn;stereo++){

			double compDC;  // 
			compDC = 0;

			//-----------------------------------
			// f[^؂ođ֐
			for(k = 0 ; k <  fftPoint ; k++){
				
				// p[g
				if(waveBit==8){ // 8 bit
					inDataNum = k*waveChn+fftPoint*waveChn*dwCurBlock+stereo;
					
					data[k].r =inDataNum < waveDataSize ? ((double)waveData[inDataNum]-0x80)
						* winFuncVal[k] / 0x80 : 0;
				}
				else {	// 16 bit
					inDataNum = k*2*waveChn+fftPoint*2*waveChn*dwCurBlock+stereo*2;

					if(inDataNum < waveDataSize) {
						inData = (LONG)waveData[inDataNum]+(LONG)waveData[inDataNum+1]*256;	
						if(inData>=0x8000) inData -= 0x10000; 
						data[k].r = (double)inData
							*winFuncVal[k] / 0x8000;	
					}
					else data[k].r = 0;
					
				}	

				// p[g
				data[k].i= 0; 
				
				// ɑ
				compDC += data[k].r;
			}
			
			// @0 ɂ邽ߋKi
			for(k=0 ; k< fftPoint;k++) data[k].r = (data[k].r-compDC/fftPoint);

			// f[^؂oI
			//-----------------------------------


			//-----------------------------------
			// p[XyNgvZ
			// fftPoint  data[] ̃p[XyNg߂

			CalcPowerSpec(data,fftPoint,maxBit,coss,sinn);

			
			//-------------------------------
			// f[^o	  

			// double ^z lpdFftData[]
			//--------------------
			// g i ( fftPoint/2*waveChn)
			//  `l
			//  E`l
			//    dwCurBlock( dwBlockNo)
			for(i = 0; i < fftPoint/2 ;i++){	
				lpdFftData[dwBlockNo*dwFftHeight*stereo 
					+dwBlockNo*i+dwCurBlock] = data[i].r;
			}

		// ̃`l(stereo < waveChn;stereo++)
		}   
	// ̃ubN (dwCurBlock < blockNo;dwCurBlock++)
	}

	return;	
}



//------------------------------------
// p[XyNgvZ̑O
//
// o^tCvZ sin  cos ̏d݃e[uvZ	   
// rbg̔]Ŏgpő BIT ̌vZ
BOOL PreCalcPowerSpec(double* lpdCos,  // cos e[u
					double* lpdSin,  // sin e[u
					LPDWORD lpdwMaxBit, // őrbg
					DWORD dwFftPoint  // |Cg
					){

	DWORD i,i2;
	double dRad;
	DWORD dwStage = (DWORD)(log(dwFftPoint)/log(2));

	// Sin , Cos e[uZbg
	for(i=1;i<=dwStage;i++){
		for(i2=0;i2<dwFftPoint/2;i2++){ 
		dRad = 2.*PI*(double)(i2)/(double)(1<<i); 
		lpdCos[i*dwFftPoint/2+i2] = cos(dRad);				 
		lpdSin[i*dwFftPoint/2+i2] = sin(dRad);		
		}	 
	}

	// ő BIT ̌vZ 
	i=dwFftPoint-1; 
	*lpdwMaxBit = 0;  
	while(i>0){i>>=1;(*lpdwMaxBit)++;};

	return TRUE;
}


//------------------------------------
// p[XyNgvZ
// data  COMPLEX ^̃f[^ dwFftPoint 
// p[XyNg data ()Ė߂
VOID CalcPowerSpec(COMPLEX* data,// FFT sf[^
				   DWORD dwFftPoint, // FFT ̓_
				   DWORD dwMaxBit,  // dwFftPoint ̍őrbg
				   double* dCosTable,// Cos ̃e[u
				   double* dSinTable// Sin ̃e[u
				   ){

	// FFT pϐ
	DWORD dwStage;
	DWORD dwPart;
	DWORD dwDataHeight,dwDataHeight2;

	// f[^̃|C^
	DWORD dwDataPos1,dwDataPos2,dwPoint;

	// A
	double dReal1,dReal2,dReal3,dImag1,dImag2,dImag3;

	// Gp
	DWORD i,j,k;
	double dSinn,dCoss;
		
	//------------
	// vZ
	dwPart = 1;
	for(dwStage = (DWORD)(log(dwFftPoint)/log(2));dwStage>0;dwStage--)
	{
		dwDataHeight = (DWORD)1 << dwStage; // 2^dwStage
		dwDataHeight2 = dwDataHeight/2;
		
		//--------------------------------
		// o^tCZJn
		for(j = 0; j < dwPart ;j++){	

			dwDataPos1 = dwDataHeight*j;
			dwDataPos2 = dwDataPos1+dwDataHeight2;

			for(k = 0 ; k <  dwDataHeight2 ; k++){
				
				dReal1 = data[dwDataPos1].r;	//  1
				dImag1 = data[dwDataPos1].i;	//  1
				
				dReal2 = data[dwDataPos2].r;	//  2
				dImag2 = data[dwDataPos2].i;	//  2
				
				// 킹	
				data[dwDataPos1].r = dReal1+dReal2;	// ̘a
				data[dwDataPos1].i = dImag1+dImag2; // ̘a
				
				//			  
				dReal3 = dReal1 - dReal2;	  
				dImag3 = dImag1 - dImag2;  	   
				dwPoint = dwStage*dwFftPoint/2+k;
				dCoss = dCosTable[dwPoint];
				dSinn = dSinTable[dwPoint];
				
				data[dwDataPos2].r = dReal3 * dCoss + dImag3 * dSinn;	  
				data[dwDataPos2].i = dImag3 * dCoss - dReal3 * dSinn;

				dwDataPos1++;
				dwDataPos2++;
			}
		}
		
		dwPart *=2; // p[g 2 ɕ
	}
	// vZ܂
	//---------------

	//--------------------------------
	// vfꂩƃp[XyNgvZ
	for(i = 0; i < dwFftPoint ;i+=2){
		
		//rbg𔽓]đʒuvZ
		dwDataPos1 = 0;
		j = i;
		for(k=0;k<dwMaxBit;k++){
			dwDataPos1 <<= 1;
			dwDataPos1 |= (j & 1);
			j >>= 1;
		}
		
		// p[XyNgvZđ
		data[dwDataPos1].r
			= data[i].r * data[i].r	+ data[i].i * data[i].i;
	}
}


//EOF